=== synfig-studio/brushes/CMakeLists.txt ===
add_subdirectory(CD_concept)
