=== debian/changelog ===
synfigstudio (1.5.1-1build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 17:18:11 +0000

synfigstudio (1.5.1-1build1) noble; urgency=medium

  * No-change rebuild against libglib2.0-0t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 08 Mar 2024 07:03:36 +0000

synfigstudio (1.5.1-1) unstable; urgency=medium

  * New upstream release.
  * Standards-Version: 4.6.0.

 -- Dmitry Smirnov <onlyjob@debian.org>  Sun, 10 Apr 2022 19:44:58 +1000
