=== debian/watch ===
# https://salsa.debian.org/snippets/95
# uscan(1) configuration file.
version=4

opts="\
pgpmode=none,\
repack,compression=xz,repacksuffix=+dfsg,\
dversionmangle=s{[+~]dfsg\d*}{},\
" https://github.com/synfig/synfig/releases \
  .*/archive/refs/tags/v?(\d[\d\.]+)@ARCHIVE_EXT@$
